Bulk query tasks

You can call the Create a bulk query task API to submit a complex data query to SHOPLINE. Because this is an asynchronous task, the results are not returned immediately. The execution time varies depending on the complexity of your query. Once the task is complete, the system generates a temporary file in JSON Lines (JSONL) format containing the query results. This file expires after 12 hours.

Once the query task is submitted, you can call the Get a valid bulk task API to fetch its execution status and the result file URL. You can download the file via this URL and obtain the query result data.


Limits

The following limits apply to bulk query tasks:

  • Concurrency: Bulk query tasks are executed sequentially on a per-store basis. Each store can have only one active bulk query task running at any given time. If a task is currently in progress, SHOPLINE will reject any additional bulk query tasks submitted for that store (regardless of whether they originate from the same app) until the current task is complete.
  • Access scopes: The app must be granted both the write_bulkoperation and read_bulkoperation access scopes. For more information on how to grant access scopes, refer to App authorization.
  • Data volume: A single bulk query task can retrieve a maximum of 10,000 data records.
  • API version: v20220901 or higher is required.
CAUTION

If your app does not call the Get a valid bulk task API promptly after its bulk query task completes, and another app for the same store submits a new bulk query task in the interim, subsequent calls made by your app will return the execution results of that new task. To prevent data misalignment, we highly recommend that you call the Get a valid bulk task API immediately upon task completion to fetch your result data.


Procedure

Follow the steps to perform a bulk query task:

  1. Submit a task: Call the Create a bulk query task API to submit a bulk query task.
  2. Poll for task status: Call the Get a valid bulk task API to check the task status and obtain the result file URL.
  3. Retrieve the results: Once the task is complete, download and parse the JSONL file using the provided URL to access the query results and proceed with your data processing.

Example: Export all product data

To export all product data from a SHOPLINE store for offline analysis, complete the process below:

Prerequisites

Make sure that your app has been granted the read_products, read_bulkoperation and write_bulkoperation access scopes.

Step 1: Submit a query task

Call the Create a bulk query task API to retrieve all products from the current store.

Sample request:

curl --location --request POST 'https://{handle}.myshopline.com/admin/openapi/v20260901/bulk_operation_run_query.json' \
--header 'Authorization: Bearer {accessToken}' \
--header 'Content-Type: application/json; charset=utf-8' \
--data-raw '{
"method": "GET",
"query_path": "https://{handle}.myshopline.com/admin/openapi/v20260901/products/products.json"
}'
CAUTION
  • The value of query_path must include the full URL of the target API endpoint. The URL may include filtering or query parameters as defined in the corresponding API documentation.
  • If an HTTP status code of 200 is returned, it indicates that the task has been submitted successfully.

Step 2: Retrieve task status and results

Call the Get a valid bulk task API to obtain the status and results of the query task submitted in the previous step.

TIP

Alternatively, you can subscribe to the Bulk task status updated webhook notification. When the status of a bulk query task changes, the system will trigger this webhook notification. You can inspect the following fields within the notification payload to view the task details and obtain the result file URL:

  • status: The status of the task.
  • type: The type of the task.
  • url: The result file URL of the task.

Sample request:

curl --location -g --request GET 'https://{handle}.myshopline.com/admin/openapi/v20260901/current_bulk_operation.json?type=QUERY' \
--header 'Authorization: Bearer {accessToken}' \
--header 'Content-Type: application/json; charset=utf-8' \
--data-raw ''
CAUTION

You must append type=QUERY to the request URL to specify that you are requesting a bulk query task.

Sample response:

{
"partialDataUrl": null,
"createdAt": "2023-05-24T14:53:45+08:00",
"expiredAt": null,
"reason": null,
"completedAt": null,
"errorCode": null,
"id": "gid://shopline/BulkOperation/XX",
"type": "QUERY",
"completedCount": 0,
"storeId": "xx",
"url": null,
"status": "CREATED"
}

Step 3: Download and parse the JSONL file

If the status field returned by the Get a valid bulk task API or the Bulk task status updated webhook notification is COMPLETED, it indicates that the bulk query task is complete. At this point, you can download the JSONL file via the returned url field. Each line within this file is a standalone, valid JSON value, as shown in the following example:

{"products":[{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"},"body_html":"<p>Women's Coat</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"}],"created_at":"2021-01-15T16:01:01+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":44,"image":null,"required_shipping":true,"compare_at_price":"8888.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703820546801691661","price":"8888.00","product_id":"16047038205454092052571954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038205456944179971954","option2":null,"position":1,"sku":"shopline-pre-000002","barcode":"shopline-pre-000002"}],"title":"Women's Coat","tags":"Winter Wear","published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-18T16:47:23+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038205454092052571954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"},"body_html":"<p>Knitted Cardigan</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"}],"created_at":"2021-01-15T16:05:30+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":12989,"image":null,"required_shipping":true,"compare_at_price":"12.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703825058429955139","price":"10.00","product_id":"16047038250581279877401954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038250582286510351954","option2":null,"position":1,"sku":"shopline-pre-000003","barcode":"shopline-pre-000003"}],"title":"Knitted Cardigan","tags":null,"published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-09T10:54:57+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038250581279877401954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},"body_html":"\n No transaction fees. No design or technical skills required. Integrated with multiple payment and logistic options. With over 120,000 merchants online. Everything you need for your e-commerce store.\n","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804227855397"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804378850369"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804513068056"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804664063031"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804798280754"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805033161772"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805251265575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805402260546"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805553255504"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805687473245"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805855245357"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806006240293"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806140458063"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806291452929"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806442447877"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806610220088"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806777992252"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806928987159"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807063204924"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807214199831"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807348417575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807482635364"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807633630248"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807767848028"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807935620136"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808086615081"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808220832823"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808355050529"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808506045509"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808640263253"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808740926532"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808891921424"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809042916445"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809328129050"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809512678433"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809663673411"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809814668294"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809982440540"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524810133435400"}],"created_at":"2021-01-18T10:09:38+08:00","template_path":null,"handle":"TestGoods23","variants":[{"inventory_quantity":998,"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/64a15e63737447dda83ca9668a64ddbd.jpeg?w=2000&h=682","alt":null,"id":"5759524810317984865"},"required_shipping":true,"compare_at_price":"23.00","taxable":true,"option5":null,"weight":"123.99","title":"green · L1","inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4707815481808813083","price":"23.00","product_id":"16047078154805505433761954","option3":null,"option4":null,"inventory_tracker":true,"option1":"green","id":"18047078154806512066751954","option2":"L1","position":1,"sku":"green_l1","barcode":null}],"title":"TestGoods23","tags":"123,abc,shopline","published_scope":"web","product_type":"NORMAL","updated_at":"2023-01-13T23:08:59+08:00","vendor":null,"subtitle":null,"options":[{"product_id":"16047078154805505433761954","values":["green"],"values_images":{},"name":"color","id":"16147078154806512066781954"},{"product_id":"16047078154805505433761954","values":["L1"],"values_images":{},"name":"custom_1","id":"16147078154806512066811954"}],"spu":null,"id":"16047078154805505433761954","published_at":"2021-01-18T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"}]}
{"products":[{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"},"body_html":"<p>Women's Coat</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"}],"created_at":"2021-01-15T16:01:01+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":44,"image":null,"required_shipping":true,"compare_at_price":"8888.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703820546801691661","price":"8888.00","product_id":"16047038205454092052571954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038205456944179971954","option2":null,"position":1,"sku":"shopline-pre-000002","barcode":"shopline-pre-000002"}],"title":"Women's Coat","tags":"Winter Wear","published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-18T16:47:23+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038205454092052571954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"},"body_html":"<p>Knitted Cardigan</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"}],"created_at":"2021-01-15T16:05:30+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":12989,"image":null,"required_shipping":true,"compare_at_price":"12.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703825058429955139","price":"10.00","product_id":"16047038250581279877401954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038250582286510351954","option2":null,"position":1,"sku":"shopline-pre-000003","barcode":"shopline-pre-000003"}],"title":"Knitted Cardigan","tags":null,"published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-09T10:54:57+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038250581279877401954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},"body_html":"\n No transaction fees. No design or technical skills required. Integrated with multiple payment and logistic options. With over 120,000 merchants online. Everything you need for your e-commerce store.\n","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804227855397"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804378850369"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804513068056"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804664063031"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804798280754"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805033161772"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805251265575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805402260546"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805553255504"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805687473245"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805855245357"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806006240293"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806140458063"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806291452929"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806442447877"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806610220088"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806777992252"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806928987159"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807063204924"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807214199831"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807348417575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807482635364"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807633630248"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807767848028"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807935620136"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808086615081"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808220832823"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808355050529"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808506045509"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808640263253"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808740926532"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808891921424"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809042916445"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809328129050"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809512678433"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809663673411"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809814668294"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809982440540"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524810133435400"}],"created_at":"2021-01-18T10:09:38+08:00","template_path":null,"handle":"TestGoods23","variants":[{"inventory_quantity":998,"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/64a15e63737447dda83ca9668a64ddbd.jpeg?w=2000&h=682","alt":null,"id":"5759524810317984865"},"required_shipping":true,"compare_at_price":"23.00","taxable":true,"option5":null,"weight":"123.99","title":"green · L1","inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4707815481808813083","price":"23.00","product_id":"16047078154805505433761954","option3":null,"option4":null,"inventory_tracker":true,"option1":"green","id":"18047078154806512066751954","option2":"L1","position":1,"sku":"green_l1","barcode":null}],"title":"TestGoods23","tags":"123,abc,shopline","published_scope":"web","product_type":"NORMAL","updated_at":"2023-01-13T23:08:59+08:00","vendor":null,"subtitle":null,"options":[{"product_id":"16047078154805505433761954","values":["green"],"values_images":{},"name":"color","id":"16147078154806512066781954"},{"product_id":"16047078154805505433761954","values":["L1"],"values_images":{},"name":"custom_1","id":"16147078154806512066811954"}],"spu":null,"id":"16047078154805505433761954","published_at":"2021-01-18T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"}]}
{"products":[{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"},"body_html":"<p>Women's Coat</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"}],"created_at":"2021-01-15T16:01:01+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":44,"image":null,"required_shipping":true,"compare_at_price":"8888.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703820546801691661","price":"8888.00","product_id":"16047038205454092052571954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038205456944179971954","option2":null,"position":1,"sku":"shopline-pre-000002","barcode":"shopline-pre-000002"}],"title":"Women's Coat","tags":"Winter Wear","published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-18T16:47:23+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038205454092052571954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"},"body_html":"<p>Knitted Cardigan</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"}],"created_at":"2021-01-15T16:05:30+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":12989,"image":null,"required_shipping":true,"compare_at_price":"12.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703825058429955139","price":"10.00","product_id":"16047038250581279877401954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038250582286510351954","option2":null,"position":1,"sku":"shopline-pre-000003","barcode":"shopline-pre-000003"}],"title":"Knitted Cardigan","tags":null,"published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-09T10:54:57+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038250581279877401954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},"body_html":"\n No transaction fees. No design or technical skills required. Integrated with multiple payment and logistic options. With over 120,000 merchants online. Everything you need for your e-commerce store.\n","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804227855397"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804378850369"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804513068056"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804664063031"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804798280754"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805033161772"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805251265575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805402260546"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805553255504"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805687473245"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805855245357"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806006240293"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806140458063"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806291452929"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806442447877"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806610220088"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806777992252"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806928987159"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807063204924"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807214199831"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807348417575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807482635364"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807633630248"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807767848028"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807935620136"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808086615081"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808220832823"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808355050529"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808506045509"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808640263253"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808740926532"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808891921424"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809042916445"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809328129050"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809512678433"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809663673411"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809814668294"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809982440540"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524810133435400"}],"created_at":"2021-01-18T10:09:38+08:00","template_path":null,"handle":"TestGoods23","variants":[{"inventory_quantity":998,"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/64a15e63737447dda83ca9668a64ddbd.jpeg?w=2000&h=682","alt":null,"id":"5759524810317984865"},"required_shipping":true,"compare_at_price":"23.00","taxable":true,"option5":null,"weight":"123.99","title":"green · L1","inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4707815481808813083","price":"23.00","product_id":"16047078154805505433761954","option3":null,"option4":null,"inventory_tracker":true,"option1":"green","id":"18047078154806512066751954","option2":"L1","position":1,"sku":"green_l1","barcode":null}],"title":"TestGoods23","tags":"123,abc,shopline","published_scope":"web","product_type":"NORMAL","updated_at":"2023-01-13T23:08:59+08:00","vendor":null,"subtitle":null,"options":[{"product_id":"16047078154805505433761954","values":["green"],"values_images":{},"name":"color","id":"16147078154806512066781954"},{"product_id":"16047078154805505433761954","values":["L1"],"values_images":{},"name":"custom_1","id":"16147078154806512066811954"}],"spu":null,"id":"16047078154805505433761954","published_at":"2021-01-18T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"}]}

You can use any programming language to parse this JSONL file for subsequent data processing.

Step 4: Resume interrupted tasks

If a bulk query task is interrupted for any reason, it will fail to retrieve the full dataset matching your criteria. The generated JSONL file will only contain partial results compiled up to the point of interruption. In such cases, you can fetch the partial result file URL from the partialDataUrl field returned by the Get a valid bulk task API and download the file.

CAUTION

The JSONL files provided by the url and partialDataUrl fields expire after 12 hours and will be permanently deleted afterwards.

After a bulk query task is interrupted, you can resume the query operation from where it left off using the partial result file by performing the following steps:

  1. Parse the last line of the partial result file.
  2. Extract the value of the since_id field from this line (such as 5759524798825649163).
  3. Append the following string as a query parameter to the end of the query_path parameter from your original bulk query request: since_id=5759524798825649163.
  4. Call the Create a bulk query task API to submit a new request.

Troubleshooting

SHOPLINE may terminate the execution of a bulk query task. Common causes include:

  • Insufficient access scopes: Your app does not have the access scopes required to query the target resource. Grant the required access scopes to your app, then resubmit the task.
  • Internal errors: The system encounters an unexpected internal error and fails to process your query request. You can try resubmitting the request.
  • Expired access tokens: Your app's access token expired during task execution. You must obtain a valid access token and resubmit the request.
Was this article helpful to you?